---
order: 1
title:
  zh-CN: 表单
---

## zh-CN

通过拖拽形成自定义的表单布局。

## en-US

```jsx
import React, { Component } from "react";
import { CustomForm } from "icsoc-antd-ex";
import { Button, Tooltip } from "antd";
const { EditForm, ShowForm, ResultForm } = CustomForm;
//所有数据格式
let formType = {
  attachment: {
    id: "1",
    name: "attachment_1",
    type: "attachment",
    options: {
      size: "default",
      placeholder: "请选择附件",
      upbtnstyle: "button",
      action: "/v1/ticket/upload/files",
      label: "附件",
      reqData: 0,
      defvalueInput: ""
    }
  },
  cascade: {
    id: "2",
    name: "cascade_2",
    type: "cascade",
    options: {
      size: "default",
      label: "级联",
      placeholder: "级联",
      defvalue: ["zhejiang", "hangzhou"],
      items: [
        {
          value: "zhejiang",
          label: "Zhejiang",
          children: [
            {
              value: "hangzhou",
              label: "Hangzhou",
              children: [{ value: "xihu", label: "West Lake" }]
            }
          ]
        }
      ]
    }
  },
  checkbox: {
    id: "3",
    name: "checkbox_3",
    type: "checkbox",
    options: {
      size: "default",
      label: "阿达大大大多多多多多多多多多多多多多多多多多多多多多选",
      defvalue: ["选项1", "选项2"],
      items: [
        { text: "选项1", value: "选项1" },
        { text: "选项2", value: "选项2" }
      ],
      reqData: 0,
      defvalueInput: ""
    }
  },
  city: {
    id: "4",
    name: "city_4",
    type: "city",
    options: {
      size: "default",
      label: "省市区lyg",
      placeholder: "请填写省市区...",
      rules: [{ required: true, message: "不能空111" }],
      items: [
        {
          value: "zhejiang",
          label: "Zhejiang",
          children: [
            {
              value: "hangzhou",
              label: "Hangzhou",
              children: [{ value: "xihu", label: "West Lake" }]
            }
          ]
        }
      ]
    }
  },
  datetime: {
    id: "5",
    name: "date_5",
    type: "datetime",
    options: {
      size: "default",
      placeholder: "请选择日期",
      defvalue: "2019-1-10",
      label: "日期",
      dateFormat: "YYYY-MM-DD",
      reqData: 1,
      defvalueInput: "%utetime%"
    }
  },
  email: {
    id: "6",
    name: "email_6",
    type: "email",
    options: {
      size: "default",
      placeholder: "abc@icsoc.net",
      label: "邮箱",
      reqData: 0,
      defvalueInput: ""
    }
  },
  input: {
    id: "7",
    name: "input_7",
    type: "input",
    options: {
      size: "default",
      placeholder: "请输入...",
      label: "单行",
      reqData: 1,
      defvalueInput: "%name%",
      rules: [{ required: true, message: "不能空111" }]
    }
  },
  mobile: {
    id: "10",
    name: "mobile_10",
    type: "mobile",
    options: {
      size: "default",
      placeholder: "输入手机",
      label: "手机",
      reqData: 0,
      defvalueInput: ""
    }
  },
  linkage: {
    id: "8",
    name: "linkage_8",
    type: "linkage",
    options: {
      size: "default",
      placeholder: "请输入...",
      label: "联动",
      reqData: 1,
      defvalueInput: "%name%",
      rules: [{ required: true, message: "不能空111" }],
      items: [
        { text: "1", value: "1" },
        {
          text: "2",
          value: "2",
          optionLinks: [
            {
              id: "15",
              name: "textarea_9",
              type: "textarea",
              options: {
                size: "default",
                placeholder: "请填写评论...",
                label: "多行",
                rows: 3,
                reqData: 0,
                defvalueInput: ""
              }
            },
            {
              id: "20",
              name: "input_9",
              type: "input",
              options: {
                size: "default",
                placeholder: "请填写评论...",
                label: "多行",
                rows: 3,
                reqData: 0,
                defvalueInput: ""
              }
            }
          ]
        }
      ]
    }
  },
  number: {
    id: "11",
    name: "number_11",
    type: "number",
    options: {
      size: "default",
      label: "数字",
      defvalue: 3,
      min: 1,
      max: 10,
      reqData: 0,
      defvalueInput: ""
    }
  },
  radio: {
    id: "12",
    name: "radio_12",
    type: "radio",
    options: {
      size: "default",
      placeholder: "",
      label: "单选",
      defvalue: "1",
      items: [
        { text: "A1", value: "1" },
        { text: "B1", value: "2" },
        { text: "C1", value: "3" },
        { text: "D1", value: "4" },
        { text: "E1", value: "5" },
        { text: "F1", value: "6" }
      ],
      reqData: 0,
      defvalueInput: ""
    }
  },
  select: {
    id: "13",
    name: "select_13",
    type: "select",
    options: {
      size: "default",
      placeholder: "下拉选择",
      defvalue: "lucy",
      label: "下拉",
      items: [
        { text: "苹果", value: "lucy" },
        { text: "葡萄", value: "jack" },
        { text: "香蕉", value: "Yimingh" }
      ],
      reqData: 0,
      defvalueInput: ""
    }
  },
  telephone: {
    id: "14",
    name: "telephone_14",
    type: "telephone",
    options: {
      size: "default",
      placeholder: "座机电话",
      label: "座机",
      reqData: 0,
      defvalueInput: ""
    }
  }
};

class Box extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      totalData: {}
    };
    this.controlComponentDataSource = [
      {
        id: "1",
        name: "attachment_1",
        type: "attachment",
        options: {
          size: "default",
          placeholder: "请选择附件",
          upbtnstyle: "button", // button、square
          action: "/v1/ticket/upload/files",
          label: "附件",
          reqData: 0,
          defvalueInput: ""
        }
      },
      {
        id: "2",
        name: "cascade_2",
        type: "cascade",
        options: {
          size: "default",
          label: "级联",
          placeholder: "级联",
          defvalue: ["zhejiang", "hangzhou"],
          items: [
            {
              value: "zhejiang",
              label: "Zhejiang",
              children: [
                {
                  value: "hangzhou",
                  label: "Hangzhou",
                  children: [
                    {
                      value: "xihu",
                      label: "West Lake"
                    }
                  ]
                }
              ]
            }
          ]
        }
      },
      {
        id: "3",
        name: "checkbox_3",
        type: "checkbox",
        options: {
          size: "default",
          label: "多选",
          defvalue: ["选项1", "选项2"],
          items: [
            {
              text: "选项1",
              value: "选项1"
            },
            {
              text: "选项2",
              value: "选项2"
            }
            // {
            //   text: "选项3",
            //   value: "选项3"
            // },
            // {
            //   text: "选项4",
            //   value: "选项4"
            // },
            // {
            //   text: "选项5",
            //   value: "选项5"
            // }
          ],
          reqData: 0,
          defvalueInput: ""
        }
      },

      {
        id: "4",
        name: "city_4",
        type: "city",
        options: {
          size: "default",
          label: "省市区",
          placeholder: "请填写省市区...",
          rules: [{ required: true, message: "不能空111" }],
          items: [
            {
              value: "zhejiang",
              label: "Zhejiang",
              children: [
                {
                  value: "hangzhou",
                  label: "Hangzhou",
                  children: [
                    {
                      value: "xihu",
                      label: "West Lake"
                    }
                  ]
                }
              ]
            }
          ]
        }
      },
      {
        id: "5",
        name: "date_5",
        type: "datetime",
        options: {
          size: "default",
          placeholder: "请选择日期",
          defvalue: "",
          label: "日期",
          dateFormat: "YYYY-MM-DD",
          reqData: 1,
          defvalueInput: "%utetime%"
        }
      },
      {
        id: "6",
        name: "email_6",
        type: "email",
        options: {
          size: "default",
          placeholder: "abc@icsoc.net",
          label: "邮箱",
          reqData: 0,
          defvalueInput: ""
        }
      },
      {
        id: "7",
        name: "input_7",
        type: "input",
        options: {
          size: "default",
          placeholder: "请输入...",
          label: "单行",
          reqData: 1,
          defvalueInput: "%name%",
          rules: [{ required: true, message: "不能空111" }]
        }
      },
      {
        id: "8",
        name: "linkage_8",
        type: "linkage",
        options: {
          size: "default",
          placeholder: "请输入...",
          label: "联动",
          reqData: 1,
          defvalueInput: "%name%",
          rules: [{ required: true, message: "不能空111" }],
          items: [
            {
              text: "1",
              value: "1"
            },
            {
              text: "2",
              value: "2",
              optionLinks: [
                {
                  id: "9",
                  name: "textarea_9",
                  type: "textarea",
                  options: {
                    size: "default",
                    placeholder: "请填写评论...",
                    label: "多行",
                    rows: 3,
                    reqData: 0,
                    defvalueInput: ""
                  }
                },
                {
                  id: "20",
                  name: "input_9",
                  type: "input",
                  options: {
                    size: "default",
                    placeholder: "请填写评论...",
                    label: "多行",
                    rows: 3,
                    reqData: 0,
                    defvalueInput: ""
                  }
                }
              ]
            }
          ]
        }
      },
      {
        id: "10",
        name: "mobile_10",
        type: "mobile",
        options: {
          size: "default",
          placeholder: "输入手机",
          label: "手机",
          reqData: 0,
          defvalueInput: ""
        }
      },
      {
        id: "11",
        name: "number_11",
        type: "number",
        options: {
          size: "default",
          label: "数字",
          defvalue: 3,
          min: 1,
          max: 10,
          reqData: 0,
          defvalueInput: ""
        }
      },
      {
        id: "12",
        name: "radio_12",
        type: "radio",
        options: {
          size: "default",
          placeholder: "",
          label: "单选",
          defvalue: "1",
          items: [
            {
              text: "A1",
              value: "1"
            },
            {
              text: "B1",
              value: "2"
            },
            {
              text: "C1",
              value: "3"
            },
            {
              text: "D1",
              value: "4"
            },
            {
              text: "E1",
              value: "5"
            },
            {
              text: "F1",
              value: "6"
            }
          ],
          reqData: 0,
          defvalueInput: ""
        }
      },
      {
        id: "13",
        name: "select_13",
        type: "select",
        options: {
          size: "default",
          placeholder: "下拉选择",
          defvalue: "lucy",
          label: "下拉",
          items: [
            {
              text: "苹果",
              value: "lucy"
            },
            {
              text: "葡萄",
              value: "jack"
            },
            {
              text: "香蕉",
              value: "Yimingh"
            }
          ],
          reqData: 0,
          defvalueInput: ""
        }
      },
      {
        id: "14",
        name: "telephone_14",
        type: "telephone",
        options: {
          size: "default",
          placeholder: "座机电话",
          label: "座机",
          reqData: 0,
          defvalueInput: ""
        }
      },
      {
        id: "15",
        name: "textarea_15",
        type: "textarea",
        options: {
          size: "default",
          placeholder: "请填写评论...",
          label: "多行",
          rows: 3,
          reqData: 0,
          defvalueInput: ""
        }
      }
    ];
    //前端传入数据
    this.options = {
      //前端传入变量
      data: {
        //前端传入变量
        name: 222,
        name2: 333
      },
      actions: {
        //暴露给前端方法
        onPhone: this.handlePhone, //手机打电话
        onEmail: this.handleEmail, //手机发短信
        onTelephone: this.handleTelephone //座机打电话
      }
    };
    this.totalData = {
      formTitle: "000",
      formData: [
        {
          id: "5",
          type: "datetime",
          rowKey: 3,
          columnKey: 1,
          itemId: 1
        },
        {
          id: "line1",
          name: "分割线",
          type: "line",
          drags: true,
          options: {
            label: "分割线",
            defvalue: "999",
            placeholder: "请输入分割线名称"
          },
          rowKey: 1,
          columnKey: 1,
          itemId: 2
        },
        {
          id: "6",
          type: "email",
          rowKey: 4,
          columnKey: 1,
          itemId: 3
        },
        {
          id: "8",
          type: "linkage",
          rowKey: 4,
          columnKey: 2,
          itemId: 4
        },
        {
          id: "4",
          type: "city",
          rowKey: 2,
          columnKey: 2,
          itemId: 5
        },
        {
          id: "14",
          type: "telephone",
          rowKey: 6,
          columnKey: 2,
          itemId: 6
        },
        {
          id: "line1",
          name: "分割线",
          type: "line",
          drags: true,
          options: {
            label: "分割线",
            defvalue: "888",
            placeholder: "请输入分割线名称"
          },
          isDrag: false,
          rowKey: 7,
          columnKey: 1,
          itemId: 7
        }
      ],
      formMatrix: [
        { key: 1, column: [1] },
        { key: 2, column: [1, 2] },
        { key: 3, column: [1, 2] },
        { key: 5, column: [1, 2] },
        { key: 4, column: [1, 2] },
        { key: 7, column: [1] },
        { key: 6, column: [1, 2] }
      ]
    };
  }

  componentDidMount() {
    this.totalData.formData = this.totalData.formData.map(item => {
      return { ...formType[item.type], ...item };
    });
    console.log(this.totalData);
    this.setState({
      totalData: this.totalData
    });
  }

  //保存编辑好的表单布局数据
  onSave = () => {
    const data = this.editForm.onSave();
    data.formData = data.formData.map(item => {
      return { ...formType[item.type], ...item };
    });
    console.log(data);
    this.setState({
      totalData: data
    });
  };

  render() {
    const { totalData } = this.state;
    return (
      <div id="root">
        <EditForm
          ref={ref => (this.editForm = ref)}
          list={this.controlComponentDataSource}
          totalData={totalData}
          // noTitle // 判断是否不需要设置表单标题
          btnArea={
            <Tooltip title="通过btnArea传的,会显示在这儿~😊">
              <Button
                type="primary"
                style={{ marginTop: 20 }}
                onClick={this.onSave}
              >
                保存
              </Button>
            </Tooltip>
          }
        />
      </div>
    );
  }
}

ReactDOM.render(<Box />, mountNode);
```

```css
.ant-btn.ant-btn-primary{
   transform: translate(-30px,-24px);
}

```
