import React from 'react';
import CommonType from './formType/commonType';
import DividingLine from './formType/dividingLine';

// 常规表单有   单行文本、多行文本、下拉框、多选、单选按钮、日期选择框、级联、省市区、手机、电话、邮箱、数字、联动
// 非常规表单有 附件、分割线、对接区
const commonTypeArr = [
  'input',
  'textarea',
  'select',
  'radio',
  'checkbox',
  'datetime',
  'cascade',
  'city',
  'mobile',
  'telephone',
  'email',
  'number',
  'linkage',
  'attachment',
  'association',
  'phone',
];

const FormType = ({ obj, deleteData, changeData }) => {
  if (commonTypeArr.includes(obj.type)) {
    return <CommonType obj={obj} deleteData={deleteData} />;
  }
  let form;
  switch (obj.type) {
    // 附件
    // case "attachment":
    //   return <Attachment obj={obj} deleteData={deleteData} />;
    //   break;
    // 分割线
    case 'line':
      form = (
        <DividingLine
          obj={obj}
          deleteData={deleteData}
          changeData={changeData}
        />
      );
      break;
    default:
      form = <div />;
      break;
  }
  return form;
};

export default FormType;
