/* eslint-disable react/no-multi-comp */
import React from 'react';
import { Tooltip, Input } from 'antd';

class EditDivide extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      value: '',
    };
  }

  componentDidMount() {
    const { obj: { options = {} } = {} } = this.props;
    this.setState({
      value: options.defvalue,
    });
  }

  componentWillReceiveProps(nextProps) {
    const { obj: { options = {} } = {} } = nextProps;
    this.setState({
      value: options.defvalue,
    });
  }

  change = e => {
    this.setState({
      value: e.target.value,
    });
  };

  save = () => {
    const { value } = this.state;
    const { onSave } = this.props;
    onSave(value);
  };

  cancel = () => {
    const { onCancel } = this.props;
    onCancel();
  };

  render() {
    const { obj: { options = {} } = {} } = this.props;
    const { value } = this.state;
    return (
      <div className="edit-box">
        <Input
          value={value}
          onChange={this.change}
          placeholder={options.placeholder}
        />
        <div className="edit-box-word" onClick={this.save}>
          保存
        </div>
        <div className="edit-box-word" onClick={this.cancel}>
          取消
        </div>
      </div>
    );
  }
}

class DividingLine extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      toolVisible: false,
    };
  }

  click = () => {
    this.setState({
      toolVisible: !this.state.toolVisible,
    });
  };

  cancel = () => {
    this.setState({
      toolVisible: false,
    });
  };

  save = value => {
    const { obj, changeData } = this.props;
    changeData(obj.itemId, 'defvalue', value);
    this.setState({
      toolVisible: false,
    });
  };

  render() {
    const { obj: { options = {} } = {}, obj, deleteData } = this.props;
    const { toolVisible } = this.state;

    return (
      <div className="sort-box">
        <div className="sort-box-left">
          <span className="sort-box-line-title" title={options.defvalue}>
            {options.defvalue}
          </span>
          <Tooltip
            placement="right"
            title={
              <EditDivide obj={obj} onCancel={this.cancel} onSave={this.save} />
            }
            visible={toolVisible}
            getPopupContainer={triggerNode => triggerNode.parentNode}
            overlayClassName="dividing-tip"
          >
            <i
              className="form form-rename"
              style={{ cursor: 'pointer' }}
              onClick={this.click}
            />
          </Tooltip>
        </div>
        <div className="icon-box">
          <Tooltip title="删除">
            <i
              className="form form-trash"
              onClick={() => {
                deleteData(obj.itemId, obj.id, obj);
              }}
            />
          </Tooltip>
        </div>
      </div>
    );
  }
}

export default DividingLine;
