/* eslint-disable react/prefer-stateless-function */
import React from 'react';
import { Row } from 'antd';
import FormGrid from './formGrid'; // 表单单元格组件

class FormRow extends React.Component {
  render() {
    const {
      columns,
      rowKey,
      data,
      formValue = {},
      smallScreen = false,
      defaultValue,
    } = this.props;
    return (
      <Row>
        {columns.map((column, columnIdx) => (
          <FormGrid
            columns={columns}
            rowKey={rowKey}
            columnKey={column}
            key={columnIdx}
            formValue={formValue}
            data={data.filter(item => item.columnKey === column)}
            smallScreen={smallScreen}
            defaultValue={defaultValue}
          />
        ))}
      </Row>
    );
  }
}

export default FormRow;
