import React from 'react';
import { commonForm } from '../../utils/contants';
import CommonType from './formType/commonType';
import DividingLine from './formType/dividingLine';
import Linkage from './formType/linkage';
import Association from './formType/association';
import Attachment from './formType/attachment';
import City from './formType/city';

const FormType = ({
  obj,
  form,
  options = {},
  customProps = [],
  customRules = {},
  customOptions = {},
  smallScreen = false,
  formItemLayout = {},
  storeFormData,
}) => {
  if (commonForm.includes(obj.type)) {
    return (
      <div className="sort-box">
        <CommonType
          obj={obj}
          form={form}
          options={options}
          customProps={customProps}
          customRules={customRules}
          customOptions={customOptions}
          smallScreen={smallScreen}
          formItemLayout={formItemLayout}
        />
      </div>
    );
  }
  switch (obj.type) {
    // 分割线
    case 'line':
      return <DividingLine obj={obj} />;
    // 联动
    case 'linkage':
      return (
        <div className="sort-box">
          <Linkage
            obj={obj}
            form={form}
            options={options}
            customProps={customProps}
            customRules={customRules}
            customOptions={customOptions}
            smallScreen={smallScreen}
            formItemLayout={formItemLayout}
            storeFormData={storeFormData}
          />
        </div>
      );
    case 'association':
      return (
        <div className="sort-box">
          <Association
            obj={obj}
            form={form}
            options={options}
            customProps={customProps}
            customOptions={customOptions}
            smallScreen={smallScreen}
            formItemLayout={formItemLayout}
          />
        </div>
      );
    // 附件
    case 'attachment':
      return (
        <div className="sort-box">
          <Attachment
            obj={obj}
            form={form}
            options={options}
            customProps={customProps}
            customOptions={customOptions}
            smallScreen={smallScreen}
            formItemLayout={formItemLayout}
          />
        </div>
      );
    // 省市区
    case 'city':
      return (
        <div className="sort-box">
          <City
            obj={obj}
            form={form}
            options={options}
            customProps={customProps}
            customOptions={customOptions}
            smallScreen={smallScreen}
            formItemLayout={formItemLayout}
          />
        </div>
      );
    default:
      return <div />;
  }
};

export default FormType;
