/* eslint-disable no-param-reassign */
/* eslint-disable no-use-before-define */
/* eslint-disable no-nested-ternary */
/* eslint-disable no-case-declarations */
import React from 'react';
import {
  Form,
  Input,
  Icon,
  Select,
  Radio,
  DatePicker,
  Cascader,
  InputNumber,
  Checkbox,
  Divider,
} from 'antd';
import moment from 'moment';
import { specialForm } from '../../../utils/contants';
import { getMixProps } from '../../../utils';

const CheckboxGroup = Checkbox.Group;
const RadioGroup = Radio.Group;
const { TextArea } = Input;
const { Option } = Select;
const FormItem = Form.Item;

class CommonType extends React.Component {
  cascade = e => {
    const {
      form: { setFieldsValue } = {},
      obj: { options: { items = [] } = {}, name = '' } = {},
    } = this.props;
    const arr = [];
    valueToLebal(e, items, arr);
    setFieldsValue({ [`${name}`]: arr });
    return e;
  };

  // checkbox = e => {
  //   const {
  //     form: { setFieldsValue } = {},
  //     obj: { options: { items = [] } = {}, name = "" } = {}
  //   } = this.props;
  //   let arr = [];
  //   e.forEach(v => {
  //     items.forEach(item => {
  //       if (v === item.value) {
  //         arr.push(item.text);
  //       }
  //     });
  //   });
  //   setFieldsValue({ [`${name}`]: arr });
  //   return e;
  // };

  radio = e => {
    const { value } = e.target;
    const {
      form: { setFieldsValue } = {},
      obj: { options: { items = [] } = {}, name = '' } = {},
    } = this.props;
    let str;
    items.forEach(item => {
      if (value === item.value) {
        str = item.text;
      }
    });
    setFieldsValue({ [`${name}`]: str });
    return value;
  };

  select = e => {
    const {
      form: { setFieldsValue } = {},
      obj: { options: { items = [] } = {}, name = '' } = {},
    } = this.props;
    let str;
    items.forEach(item => {
      if (e === item.value) {
        str = item.text;
      }
    });
    setFieldsValue({ [`${name}`]: str });
    return e;
  };

  onEmail = obj => {
    const {
      form: { getFieldValue } = {},
      options: { actions: { onEmail = () => {} } = {} } = {},
    } = this.props;
    const data = getFieldValue(obj.name);
    onEmail(data, obj);
  };

  onPhone = obj => {
    const {
      form: { getFieldValue } = {},
      options: { actions: { onPhone = () => {} } = {}, actions } = {},
    } = this.props;
    const data = getFieldValue(obj.name);
    onPhone(data, obj);
  };

  onTelephone = obj => {
    const {
      form: { getFieldValue } = {},
      options: { actions: { onTelephone = () => {} } = {} } = {},
    } = this.props;

    const data = getFieldValue(obj.name);
    onTelephone(data, obj);
  };

  render() {
    let formData;
    let AddonAfterFormItem = null; // 表单项后面需要单独加的部分，如InputNumber的单位
    const {
      form: { getFieldDecorator } = {},
      obj = {},
      customProps,
      customOptions: { noDefValue },
      smallScreen = false,
      formItemLayout: layout = {},
      customRules = {},
    } = this.props;
    const props = getMixProps(customProps, obj);
    const option = obj.options || {};
    const { readonly = false } = option;

    if (!obj.id) return <div />;
    // const { activeObj } = this.state;
    switch (obj.type) {
      // 单行文本
      case 'input':
        formData = (
          <Input
            size={option.size || 'default'}
            placeholder={option.placeholder || ''}
            disabled={readonly}
            {...props}
          />
        );
        break;
      // 多行文本
      case 'textarea':
        formData = (
          <TextArea
            size={option.size || 'default'}
            rows={option.rows || 3}
            placeholder={option.placeholder || ''}
            disabled={readonly}
            {...props}
          />
        );
        break;
      // 下拉框
      case 'select':
        formData = (
          <Select
            size={option.size || 'default'}
            placeholder={option.placeholder || ''}
            disabled={readonly}
            getPopupContainer={triggerNode => triggerNode.parentNode}
            {...props}
          >
            {option.items && Array.isArray(option.items)
              ? option.items.map((item, idx) => (
                  <Option key={idx} value={item.value}>
                    {item.text}
                  </Option>
                ))
              : null}
          </Select>
        );
        break;
      // 单选按钮
      case 'radio':
        formData = (
          <RadioGroup
            size={option.size || 'default'}
            disabled={readonly}
            {...props}
          >
            {option.items && Array.isArray(option.items)
              ? option.items.map((item, idx) => (
                  <Radio key={idx} value={item.value}>
                    {item.text}
                  </Radio>
                ))
              : null}
          </RadioGroup>
        );
        break;
      // 多选
      case 'checkbox':
        formData = (
          <CheckboxGroup
            size={option.size || 'default'}
            disabled={readonly}
            {...props}
          >
            {option.items && Array.isArray(option.items)
              ? option.items.map((item, idx) => (
                  <Checkbox value={item.value} key={idx}>
                    {item.text}
                  </Checkbox>
                ))
              : null}
          </CheckboxGroup>
        );
        break;
      // 日期选择框
      case 'datetime':
        formData = (
          <DatePicker
            showTime={option.dateFormat !== 'YYYY-MM-DD'}
            size={option.size || 'default'}
            placeholder={option.placeholder || ''}
            format={option.dateFormat}
            disabled={readonly}
            getCalendarContainer={triggerNode => triggerNode.parentNode}
            {...props}
          />
        );
        break;
      // 级联
      case 'cascade':
        formData = (
          <Cascader
            showSearch
            popupClassName="custom-form-cascade"
            size={option.size || 'default'}
            options={option.items || []}
            placeholder={option.placeholder || ''}
            disabled={readonly}
            getPopupContainer={triggerNode => triggerNode.parentNode}
            expandTrigger="hover"
            {...props}
          />
        );
        break;
      // phone
      case 'phone':
        formData = (
          <Input
            placeholder={option.placeholder || ''}
            // addonAfter={addonAfter}
            autoComplete="off"
            disabled={readonly}
            maxLength={20}
            {...props}
          />
        );
        break;
      // 手机
      case 'mobile':
        const selectAfter = (
          <div>
            <Icon
              type="phone"
              onClick={() => {
                this.onPhone(obj);
              }}
            />
            <Icon
              type="mail"
              onClick={() => {
                this.onEmail(obj);
              }}
            />
          </div>
        );
        formData = (
          <Input
            addonAfter={selectAfter}
            size={option.size || 'default'}
            disabled={readonly}
            placeholder={option.placeholder || ''}
            {...props}
          />
        );
        break;
      // 电话
      case 'telephone':
        formData = (
          <Input
            addonAfter={
              <div>
                <Icon
                  type="phone"
                  onClick={() => {
                    this.onTelephone(obj);
                  }}
                />
              </div>
            }
            size={option.size || 'default'}
            placeholder={option.placeholder || ''}
            disabled={readonly}
            {...props}
          />
        );
        break;
      // 邮箱
      case 'email':
        formData = (
          <Input
            size={option.size || 'default'}
            placeholder={option.placeholder || ''}
            disabled={readonly}
            {...props}
          />
        );
        break;
      // 数字
      case 'number':
        formData = (
          <InputNumber
            className={option.unit ? 'has-unit' : ''}
            size={option.size || 'default'}
            placeholder={option.placeholder || undefined}
            min={option.min || -Infinity}
            max={option.max || Infinity}
            disabled={readonly}
            {...props}
          />
        );
        AddonAfterFormItem = option.unit ? (
          <div className="unit-box" title={option.unit}>
            &nbsp;{`/${option.unit}`}
          </div>
        ) : null;
        break;
      default:
        formData = <div />;
        break;
    }
    const { rules } = option;
    let newRules = [];
    if (rules && Array.isArray(rules) && rules.length) {
      newRules = rules.map(item => {
        if (item && item.required && !item.message) {
          item.message = `${option.label}不能为空`;
          if (['input', 'textarea'].includes(obj.type)) item.whitespace = true;
        }
        return item;
      });
    }
    if (customRules[obj.type]) {
      newRules = newRules.concat(customRules[obj.type]);
    }
    newRules = newRules.filter(item => item);
    const initialValue =
      option.defvalue && !noDefValue
        ? obj.type === 'datetime'
          ? moment(option.defvalue, option.dateFormat)
          : option.defvalue
        : undefined;
    const fieldProps = {
      valuePropName: 'value',
      initialValue,
      rules: newRules,
    };
    if (obj.type === 'cascade') {
      fieldProps.getValueFromEvent = this.cascade;
    } else if (obj.type === 'radio') {
      fieldProps.getValueFromEvent = this.radio;
    } else if (obj.type === 'select') {
      fieldProps.getValueFromEvent = this.select;
    }

    let specialInitialValue;
    if (initialValue && specialForm.includes(obj.type)) {
      obj.options.items.map(v => {
        if (initialValue === v.value) {
          specialInitialValue = v.text;
        }
        return v;
      });
    }
    const formItemLayout = smallScreen ? layout : {};
    return (
      <React.Fragment>
        {specialForm.includes(obj.type) ? (
          <React.Fragment>
            <FormItem
              label={
                <div className="inner-box" title={option.label || ''}>
                  {option.label || ''}
                </div>
              }
              {...formItemLayout}
            >
              {getFieldDecorator(`${obj.name}_ids`, fieldProps)(formData)}
            </FormItem>
            <FormItem style={{ display: 'none' }}>
              {getFieldDecorator(`${obj.name}`, {
                initialValue: specialInitialValue,
              })(<div />)}
              {AddonAfterFormItem}
            </FormItem>
          </React.Fragment>
        ) : (
          <FormItem
            label={
              <div className="inner-box" title={option.label || ''}>
                {option.label || ''}
              </div>
            }
            {...formItemLayout}
          >
            {getFieldDecorator(`${obj.name}`, fieldProps)(formData)}
            {AddonAfterFormItem}
          </FormItem>
        )}
        {/* {activeObj ? (
          <CommonType obj={activeObj} form={form} options={options} />
        ) : null} */}
      </React.Fragment>
    );
  }
}

function valueToLebal(valueArr, items, finalArr) {
  valueArr.forEach(value => {
    items.forEach(item => {
      if (value === item.value) {
        finalArr.push(item.label);
        valueArr = valueArr.filter(arr => arr !== value);
        if (valueArr.length) {
          valueToLebal(valueArr, item.children, finalArr);
        }
      }
    });
  });
}

export default CommonType;
