import React from 'react';
import { Col } from 'antd';
import FormType from './components/formType';

class FormGrid extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      data: [],
    };
  }

  componentDidMount() {
    const { data = [] } = this.props;
    this.setState({
      data,
    });
  }

  componentWillReceiveProps(nextProps) {
    const { data } = nextProps;
    this.setState({
      data,
    });
  }

  render() {
    const { data } = this.state;
    const {
      columns = [1, 2],
      form,
      options = {},
      customProps = [],
      customRules = {},
      customOptions = {},
      smallScreen = false,
      formItemLayout = {},
      storeFormData,
    } = this.props;
    const num = 1;
    const span = smallScreen
      ? null
      : columns && columns.length ? 24 / columns.length : 12;

    return (
      <Col span={span}>
        {data.map(i => (
          <FormType
            key={i.name}
            obj={i}
            form={form}
            options={options}
            customProps={customProps}
            customOptions={customOptions}
            smallScreen={smallScreen}
            formItemLayout={formItemLayout}
            customRules={customRules}
            storeFormData={storeFormData}
          />
        ))}
      </Col>
    );
  }
}

export default FormGrid;
