import React from 'react';
import { Form } from 'antd';
import moment from 'moment';
import classnames from 'classnames';
import FormRow from './formRow'; // 表单行组件
import { specialForm } from '../utils/contants';

class ShowForm extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      totalData: {},
      options: {},
      customProps: [],
      customRules: {},
      customOptions: {}, // 全局配置
      prevStoreFormData: {}, // 表单回显数据
      prevFormData: {}, // 上一次需要回显的值
      prevRenderFrom: {},
      prevData: {},
      prevRenderInitialFrom: {},
      prevInitialData: {},
      // prevInitalData: {}, // 初始化接口数据
      // isInterface: false, // 是否调用初始化接口
      // customData: {}, // 需要自定义注入的变量
    };
    this.timer = null;
  }

  componentDidMount() {
    this.props.onRef(this); // 把this传出去
    const {
      totalData: { formData = [] } = {},
      options: { data = {} } = {},
      customProps = [],
      customRules = {},
      customOptions = {},
      form: { setFieldsValue = () => {}, getFieldsValue = () => {} } = {},
      form,
      totalData = {},
      options = {},
      storeFormData = {},
    } = this.props;
    this.setState({
      totalData,
      options,
      customProps,
      customRules,
      customOptions,
    });
    this.timer = window.setTimeout(() => {
      this.resetFieldsValue(this.props);
      this.editFieldsValue(this.props);
    }, 100);
  }

  componentWillReceiveProps(nextProps) {
    const {
      totalData: { formData = [] } = {},
      options: { data = {} } = {},
      customProps = [],
      customRules = {},
      customOptions = {},
      form: { setFieldsValue = () => {}, getFieldsValue = () => {} } = {},
      totalData = {},
      options = {},
      form,
      storeFormData = {},
    } = nextProps;
    // const { customProps = [], totalData = {}, options = {} } = nextProps;
    this.setState({
      totalData,
      options,
      customProps,
      customRules,
      customOptions,
    });
    this.timer = window.setTimeout(() => {
      this.resetFieldsValue(nextProps);
      this.editFieldsValue(nextProps);
    }, 100);
  }

  componentWillUnmount() {
    window.clearTimeout(this.timer);
  }

  // 编辑时回显表单数据
  editFieldsValue = props => {
    const {
      totalData: { formData = [] } = {},
      options: { data = {} } = {},
      customProps = [],
      form: {
        setFieldsValue = () => {},
        getFieldsValue = () => {},
        getFieldDecorator,
      } = {},
      customOptions: { phoneHidden = false } = {},
      totalData = {},
      options = {},
      form,
      storeFormData = {},
    } = props;
    // 表单回显
    const arr2 = Object.keys(storeFormData);

    // console.log(getFieldDecorator());
    if (arr2.length) {
      const obj = {};
      const formValue = getFieldsValue();
      const arr = Object.keys(formValue);
      // this.setState({
      //   prevFormData: storeFormData,
      //   prevRenderFrom: formValue
      // });
      // const formValue = deepClone(getFieldsValue());
      if (arr && arr.length) {
        // 当前渲染出的表单
        // let arr3 = Object.keys(formValue);
        formData.forEach(item => {
          const { options: { items = [] } = {} } = item;
          if (arr2.includes(item.name)) {
            if (item.type === 'phone') {
              obj[item.name] = phoneHidden
                ? (storeFormData[item.name] || '')
                    .replace(/[A-Za-z]/g, '*')
                    .replace(/(.{3}).{1,4}(.{0})/, '$1****$2')
                : storeFormData[item.name];
            } else if (item.type === 'datetime') {
              obj[item.name] = storeFormData[item.name]
                ? moment(storeFormData[item.name], item.options.dateFormat)
                : undefined;
              // 下拉 单选
            } else if (item.type === 'select' || item.type === 'radio') {
              const value = storeFormData[`${item.name}_ids`];
              const selected = editSingleFilterUseless(value, items);
              obj[`${item.name}_ids`] = selected ? selected.value : undefined;
              obj[`${item.name}`] = selected ? selected.text : undefined;
              // console.log(item.name, selected);
              // 多选
            } else if (item.type === 'checkbox') {
              // obj[item.name] = data[defaultValue].split(",");
              const valueArr = storeFormData[`${item.name}`];
              const finalArr = editCheckFilterUseless(valueArr, items, []);
              obj[item.name] = finalArr;
              // 省市区
            } else if (item.type === 'city') {
              obj[item.name] = storeFormData[`${item.name}`];
              obj[`${item.name}_ids`] = storeFormData[`${item.name}`];
              // 级联
            } else if (item.type === 'cascade') {
              const valueArr = storeFormData[`${item.name}_ids`];
              const finalArr = [];
              editCascadeFilterUseless(valueArr, items, finalArr);
              obj[`${item.name}_ids`] = finalArr;
              const arr = [];
              valueToLebal(finalArr, items, arr);
              obj[`${item.name}`] = arr.length ? arr : undefined;
            } else if (item.type === 'linkage') {
              const value = storeFormData[`${item.name}_ids`];
              const selected = editSingleFilterUseless(value, items);
              obj[`${item.name}_ids`] = selected ? selected.value : undefined;
              obj[`${item.name}`] = selected ? selected.text : undefined;
              const { options: { items: itemsArr = [] } = {} } = item;
              if (itemsArr && itemsArr.length) {
                itemsArr.forEach(v => {
                  if (v && v.optionLinks && v.optionLinks.length) {
                    v.optionLinks.forEach(a => {
                      const { options: { items: itemsArr = [] } = {} } = a;
                      if (arr.includes(a.name)) {
                        if (a.type === 'datetime') {
                          obj[a.name] = storeFormData[a.name]
                            ? moment(
                                storeFormData[a.name],
                                a.options.dateFormat,
                              )
                            : undefined;
                          // 下拉 单选
                        } else if (a.type === 'select' || a.type === 'radio') {
                          const value = storeFormData[`${a.name}_ids`];
                          const selected = editSingleFilterUseless(
                            value,
                            itemsArr,
                          );
                          obj[`${a.name}_ids`] = selected
                            ? selected.value
                            : undefined;
                          obj[`${a.name}`] = selected
                            ? selected.text
                            : undefined;
                          // 多选
                        } else if (a.type === 'checkbox') {
                          // obj[a.name] = data[defaultValue].split(",");
                          const valueArr = storeFormData[`${a.name}`];
                          const finalArr = editCheckFilterUseless(
                            valueArr,
                            itemsArr,
                            [],
                          );
                          obj[a.name] = finalArr;
                          // 省市区
                        } else if (a.type === 'city') {
                          obj[a.name] = storeFormData[`${a.name}`];
                          obj[`${a.name}_ids`] = storeFormData[`${a.name}`];
                          // 级联
                        } else if (a.type === 'cascade') {
                          const valueArr = storeFormData[`${a.name}_ids`];
                          const finalArr = [];
                          editCascadeFilterUseless(
                            valueArr,
                            a.options.items,
                            finalArr,
                          );

                          obj[`${a.name}_ids`] = finalArr;

                          const arr = [];
                          valueToLebal(finalArr, a.options.items, arr);
                          obj[`${a.name}`] = arr.length ? arr : undefined;

                          // let arr = [];
                          // obj[`${a.name}`] =
                          //   finalArr && finalArr.length
                          //     ? valueToLebal(finalArr, as, arr)
                          //     : undefined;
                        } else {
                          obj[a.name] =
                            storeFormData[a.name] || storeFormData[a.name] === 0
                              ? storeFormData[a.name]
                              : undefined;
                        }

                        // if (a.type === "datetime") {
                        //   obj[a.name] = storeFormData[a.name]
                        //     ? moment(
                        //         storeFormData[a.name],
                        //         a.options.dateFormat
                        //       )
                        //     : undefined;
                        // } else {
                        //   if (specialForm.includes(a.type)) {
                        //     obj[`${a.name}_ids`] =
                        //       storeFormData[`${a.name}_ids`] || undefined;
                        //   }
                        //   obj[a.name] = storeFormData[a.name] || undefined;
                        // }
                      }
                    });
                  }
                });
              }
              // obj[item.name] =
              //   storeFormData[item.name] || storeFormData[item.name] === 0
              //     ? storeFormData[item.name]
              //     : undefined;
            } else {
              obj[item.name] =
                storeFormData[item.name] || storeFormData[item.name] === 0
                  ? storeFormData[item.name]
                  : undefined;
            }
          }
        });
        const { prevStoreFormData } = this.state;
        const storeData = prevStoreFormData;
        // 重新转换附件格式
        formData.forEach(item => {
          // 转换普通附件
          if (
            item.type === 'attachment' &&
            obj[item.name] &&
            typeof obj[item.name] === 'string' &&
            Array.isArray(JSON.parse(obj[item.name]))
          ) {
            const fileList = [];
            storeData[item.name] = prevStoreFormData[item.name]
              ? prevStoreFormData[item.name].map(item => {
                  delete item.status;
                  return item;
                })
              : undefined;
            JSON.parse(obj[item.name]).forEach(file => {
              fileList.push(file.file);
            });
            obj[item.name] = fileList;
            // obj[item.name] = JSON.parse(obj[item.name]);
          } else if (item.type === 'linkage') {
            // 转换联动下的附件
            const { options: { items = [] } = {} } = item;
            if (items && items.length) {
              items.forEach(v => {
                if (v && v.optionLinks && v.optionLinks.length) {
                  v.optionLinks.forEach(a => {
                    if (
                      a.type === 'attachment' &&
                      obj[a.name] &&
                      typeof obj[a.name] === 'string' &&
                      Array.isArray(JSON.parse(obj[a.name]))
                    ) {
                      const fileList = [];
                      storeData[a.name] = prevStoreFormData[a.name]
                        ? prevStoreFormData[a.name].map(b => {
                            delete b.status;
                            return b;
                          })
                        : undefined;
                      JSON.parse(obj[a.name]).forEach(file => {
                        fileList.push(file.file);
                      });
                      obj[a.name] = fileList;
                      // obj[item.name] = JSON.parse(obj[item.name]);
                    } else {
                      obj[item.name] =
                        storeFormData[item.name] ||
                        storeFormData[item.name] === 0
                          ? storeFormData[item.name]
                          : undefined;
                    }
                  });
                }
              });
            }
          }
        });
        const { prevFormData, prevRenderFrom } = this.state;
        const prevRenderFromArr = Object.keys(prevRenderFrom);
        const formValueArr = Object.keys(formValue);
        if (
          JSON.stringify(prevRenderFromArr) !== JSON.stringify(formValueArr) ||
          JSON.stringify(prevFormData) !== JSON.stringify(storeFormData)
        ) {
          const newObj = {};
          for (const i in obj) {
            if (!prevStoreFormData[i] && obj[i] !== undefined) {
              newObj[i] = obj[i];
            }
          }
          this.setState({
            prevStoreFormData: obj,
            prevFormData: storeFormData,
            prevRenderFrom: formValue,
          });
          setFieldsValue(newObj);
        }
      }
    }
  };

  // 自定义变量重置导入变量
  resetFieldsValue = props => {
    const {
      totalData: { formData = [] } = {},
      options: { data = {} } = {},
      form: { setFieldsValue = () => {}, getFieldsValue = () => {} } = {},
    } = props;
    // 子组件更新时判断是否需要重新注入变量
    // 初始化接口
    // 初始化接口需要做两件事：1、数据格式转换；2、ids赋值
    const arr2 = Object.keys(data);
    if (arr2.length) {
      const obj = {};
      const formValue = getFieldsValue();
      // 1、数据格式转换
      const arr = Object.keys(formValue);
      if (arr && arr.length) {
        // 当前渲染出的表单
        const arr3 = Object.keys(formValue);
        formData.forEach(item => {
          const {
            name,
            options: { defvalueInput = '', items = [], defvalue = '' } = {},
          } = item;
          const defaultValue = defvalueInput
            ? defvalueInput.replace(/%/g, '')
            : '';

          if (
            ((defvalueInput && arr2.includes(defaultValue)) || defvalue) &&
            arr3.includes(item.name)
          ) {
            // 日期
            if (item.type === 'datetime') {
              if (
                data[defaultValue] &&
                typeof data[defaultValue] === 'string' &&
                isLongDate(data[defaultValue])
              ) {
                obj[item.name] = moment(
                  data[defaultValue],
                  'YYYY-MM-DD HH:mm:ss',
                );
              } else if (
                data[defaultValue] &&
                typeof data[defaultValue] === 'string' &&
                isShortDate(data[defaultValue])
              ) {
                obj[item.name] = moment(data[defaultValue], 'YYYY-MM-DD');
              }
              // 多选
            } else if (item.type === 'checkbox') {
              if (
                data[defaultValue] &&
                typeof data[defaultValue] === 'string'
              ) {
                // obj[item.name] = data[defaultValue].split(",");
                const labelArr = data[defaultValue].split(',');
                const finalArr = resetCheckFilterUseless(labelArr, items, []);
                obj[item.name] = finalArr;
              }
              // 邮箱
            } else if (
              item.type === 'email' ||
              item.type === 'input' ||
              item.type === 'mobile' ||
              item.type === 'telphone' ||
              item.type === 'textarea'
            ) {
              if (
                data[defaultValue] &&
                typeof data[defaultValue] === 'string'
              ) {
                obj[item.name] = data[defaultValue];
              }
              // 数字
            } else if (item.type === 'number') {
              if (
                (data[defaultValue] || data[defaultValue] === 0) &&
                typeof data[defaultValue] === 'number'
              ) {
                obj[item.name] = data[defaultValue];
              }
              // 省市区
            } else if (item.type === 'city') {
              if (
                data[defaultValue] &&
                typeof data[defaultValue] === 'string'
              ) {
                obj[item.name] = data[defaultValue].split('/');
                obj[`${item.name}_ids`] = data[defaultValue].split('/');
              }
              // 级联
            } else if (item.type === 'cascade') {
              if (
                data[defaultValue] &&
                typeof data[defaultValue] === 'string'
              ) {
                const labelArr = data[defaultValue].split('/');
                const finalArr = resetCascadeFilterUseless(labelArr, items, []);
                obj[`${item.name}`] = finalArr;
                const arr = [];
                obj[`${item.name}_ids`] =
                  finalArr && finalArr.length
                    ? labelToValue(finalArr, items, arr)
                    : undefined;
                // obj[`${item.name}_ids`] = labelArr;
                // let arr = [];
                // obj[`${item.name}`] = labelArr
                //   ? labelToValue(labelArr, items, arr)
                //   : undefined;
              }
              // 下拉与单选
            } else if (item.type === 'select' || item.type === 'radio') {
              if (
                data[defaultValue] &&
                typeof data[defaultValue] === 'string'
              ) {
                const label = data[defaultValue];
                const selected = resetSingleFilterUseless(label, items);
                obj[`${item.name}_ids`] = selected ? selected.value : undefined;
                obj[`${item.name}`] = selected ? selected.text : undefined;
                // obj[`${item.name}_ids`] = label;
                // let str;
                // items.forEach(item => {
                //   if (label === item.text) {
                //     str = item.value;
                //   }
                // });
                // obj[`${item.name}`] = label ? str : undefined;
              }
              // 联动
            } else if (item.type === 'linkage') {
              const label = data[defaultValue];
              const selected = resetSingleFilterUseless(label, items);
              obj[`${item.name}_ids`] = selected ? selected.value : undefined;
              obj[`${item.name}`] = selected ? selected.text : undefined;
              // obj[`${item.name}`] = label;
              let str;
              items.forEach(item => {
                if (label === item.text) {
                  str = item.value;
                }
                if (
                  item.optionLinks &&
                  Array.isArray(item.optionLinks) &&
                  item.optionLinks.length
                ) {
                  item.optionLinks.forEach(a => {
                    const linkName = a.name || undefined;
                    const linkDefInput =
                      a.options && a.options.defvalueInput
                        ? a.options.defvalueInput
                        : '';
                    const defaultlinkDefInput = linkDefInput
                      ? linkDefInput.replace(/%/g, '')
                      : '';
                    const items =
                      a.options && a.options.items ? a.options.items : [];
                    if (
                      defaultlinkDefInput &&
                      arr3.includes(linkName) &&
                      arr2.includes(defaultlinkDefInput)
                    ) {
                      // 日期
                      if (a.type === 'datetime') {
                        if (
                          data[defaultlinkDefInput] &&
                          typeof data[defaultlinkDefInput] === 'string' &&
                          isLongDate(data[defaultlinkDefInput])
                        ) {
                          obj[a.name] = moment(
                            data[defaultlinkDefInput],
                            'YYYY-MM-DD HH:mm:ss',
                          );
                        } else if (
                          data[defaultlinkDefInput] &&
                          typeof data[defaultlinkDefInput] === 'string' &&
                          isShortDate(data[defaultlinkDefInput])
                        ) {
                          obj[a.name] = moment(
                            data[defaultlinkDefInput],
                            'YYYY-MM-DD',
                          );
                        }
                        // 多选
                      } else if (a.type === 'checkbox') {
                        if (
                          data[defaultlinkDefInput] &&
                          typeof data[defaultlinkDefInput] === 'string'
                        ) {
                          // obj[a.name] = data[defaultlinkDefInput].split(",");
                          const labelArr = data[defaultlinkDefInput].split(',');
                          const finalArr = resetCheckFilterUseless(
                            labelArr,
                            items,
                            [],
                          );
                          obj[a.name] = finalArr;
                        }
                        // 邮箱
                      } else if (
                        a.type === 'email' ||
                        a.type === 'input' ||
                        a.type === 'mobile' ||
                        a.type === 'telphone' ||
                        a.type === 'textarea'
                      ) {
                        if (
                          data[defaultlinkDefInput] &&
                          typeof data[defaultlinkDefInput] === 'string'
                        ) {
                          obj[a.name] = data[defaultlinkDefInput];
                        }
                        // 数字
                      } else if (a.type === 'number') {
                        if (
                          (data[defaultlinkDefInput] ||
                            data[defaultlinkDefInput] === 0) &&
                          typeof data[defaultlinkDefInput] === 'number'
                        ) {
                          obj[a.name] = data[defaultlinkDefInput];
                        }
                        // 省市区
                      } else if (a.type === 'city') {
                        if (
                          data[defaultlinkDefInput] &&
                          typeof data[defaultlinkDefInput] === 'string'
                        ) {
                          obj[a.name] = data[defaultlinkDefInput].split('/');
                          obj[`${a.name}_ids`] = data[
                            defaultlinkDefInput
                          ].split('/');
                        }
                        // 级联
                      } else if (a.type === 'cascade') {
                        if (
                          data[defaultlinkDefInput] &&
                          typeof data[defaultlinkDefInput] === 'string'
                        ) {
                          const labelArr = data[defaultlinkDefInput].split('/');
                          const finalArr = resetCascadeFilterUseless(
                            labelArr,
                            items,
                            [],
                          );
                          obj[`${a.name}`] = finalArr;
                          const arr = [];
                          obj[`${a.name}_ids`] =
                            finalArr && finalArr.length
                              ? labelToValue(finalArr, items, arr)
                              : undefined;
                          // obj[`${a.name}`] = labelArr;
                          // let arr = [];
                          // obj[`${a.name}_ids`] = labelArr
                          //   ? labelToValue(labelArr, items, arr)
                          //   : undefined;
                        }
                        // 下拉与单选
                      } else if (a.type === 'select' || a.type === 'radio') {
                        if (
                          data[defaultlinkDefInput] &&
                          typeof data[defaultlinkDefInput] === 'string'
                        ) {
                          const label = data[defaultlinkDefInput];
                          const selected = resetSingleFilterUseless(
                            label,
                            items,
                          );
                          obj[`${a.name}_ids`] = selected
                            ? selected.value
                            : undefined;
                          obj[`${a.name}`] = selected
                            ? selected.text
                            : undefined;

                          // obj[`${a.name}`] = label;
                          // let str;
                          // items.forEach(b => {
                          //   if (label === b.text) {
                          //     str = b.value;
                          //   }
                          // });
                          // obj[`${a.name}_ids`] = label ? str : undefined;
                        }
                      }
                    }
                  });
                }
              });
              // obj[`${item.name}_ids`] = label ? str : undefined;
            } else {
              obj[item.name] = data[defaultValue] || undefined;
            }
          }
        });
        // const { prevInitalData } = this.state;

        // if (JSON.stringify(prevInitalData) !== JSON.stringify(obj)) {
        //   this.setState({
        //     prevInitalData: obj
        //   });
        //   setFieldsValue(obj);
        // }
        const { prevData, prevRenderInitialFrom, prevInitialData } = this.state;
        if (
          JSON.stringify(prevRenderInitialFrom) !== JSON.stringify(formValue) ||
          JSON.stringify(prevData) !== JSON.stringify(data) ||
          JSON.stringify(obj) !== JSON.stringify(prevInitialData)
        ) {
          const newObj = {};
          for (const i in obj) {
            if (!prevInitialData[i] && obj[i] !== undefined) {
              newObj[i] = obj[i];
            }
          }
          this.setState({
            prevInitialData: obj,
            prevData: data,
            prevRenderInitialFrom: formValue,
          });
          setFieldsValue(newObj);
        }
      }

      // let arr = Object.keys(data);
      // if (arr.length) {
      //   const obj = {};
      //   formData.forEach(item => {
      //     const { options: { defvalueInput = "" } = {} } = item;
      //     if (defvalueInput) {
      //       //获取变量名
      //       const defaultValue = defvalueInput.replace(/%/g, "");
      //       //变量是否注入值
      //       if (arr.includes(defaultValue) && data[defaultValue]) {
      //         obj[item.name] = data[defaultValue];
      //       } else {
      //         obj[item.name] = undefined;
      //       }
      //     }
      //   });
      //   const { customData } = this.state;
      //   let newObj = {};
      //   for (let i in obj) {
      //     if (obj[i] !== customData[i]) {
      //       newObj[i] = obj[i];
      //     }
      //   }
      //   this.setState({
      //     customData: obj
      //   });
      //   if (Object.keys(newObj).length) {
      //     setFieldsValue(newObj);
      //   }
      // }
    }
  };

  onSave = () => {
    const {
      form: { getFieldsValue, validateFieldsAndScroll } = {},
      totalData: { formData = [] } = {},
      onSubmit,
    } = this.props;
    // const { totalData: { formData = [] } = {} } = this.state;
    let flag = 0;
    let data = [];
    validateFieldsAndScroll(errors => {
      if (errors) {
        return;
      }
      flag = 1;
      data = {
        ...getFieldsValue(),
      };
      // 重新转换附件格式
      formData.forEach(item => {
        if (
          item.type === 'attachment' &&
          data[item.name] &&
          Array.isArray(data[item.name]) &&
          data[item.name].length
        ) {
          const arr = [];
          data[item.name].forEach(item => {
            if (item.status === 'uploading') {
              flag = 2;
            }
            if (
              item.status &&
              (item.status !== 'error' && item.status !== 'removed')
            ) {
              const { response: { data: _data } = {} } = item;
              const file = {
                uid: item.uid,
                name: item.name,
                // 兼容工单和CRM上传成功返回的数据结构差异
                url: _data ? _data.file_url || _data : undefined,
              };
              arr.push({ file });
            }
            if (!item.status) {
              const file = {
                uid: item.uid,
                name: item.name,
                url: item.url || undefined,
              };
              arr.push({ file });
            }
          });
          data[item.name] = JSON.stringify(arr);
        } else if (item.type === 'linkage') {
          const { options: { items = [] } = {} } = item;
          items.forEach(v => {
            if (v.optionLinks && v.optionLinks.length) {
              v.optionLinks.forEach(a => {
                if (
                  a.type === 'attachment' &&
                  data[a.name] &&
                  Array.isArray(data[a.name]) &&
                  data[a.name].length
                ) {
                  // let arr = [];
                  // if (a.status === "uploading") {
                  //   flag = 2;
                  // }
                  // if (
                  //   a.status &&
                  //   (a.status !== "error" && a.status !== "removed")
                  // ) {
                  //   const file = {
                  //     uid: a.uid,
                  //     name: a.name,
                  //     url: a.response ? a.response.data : undefined
                  //   };
                  //   arr.push({ file: file });
                  // }
                  // if (!a.status) {
                  //   const file = {
                  //     uid: a.uid,
                  //     name: a.name,
                  //     url: a.url || undefined
                  //   };
                  //   arr.push({ file: file });
                  // }
                  const arr = [];
                  data[a.name].forEach(a => {
                    if (a.status === 'uploading') {
                      flag = 2;
                    }
                    // if (a.status === "done") {
                    //   const file = {
                    //     uid: a.uid,
                    //     name: a.name,
                    //     url: a.response ? a.response.data : undefined
                    //   };
                    //   arr.push({ file: file });
                    // }
                    if (
                      a.status &&
                      (a.status !== 'error' && a.status !== 'removed')
                    ) {
                      const { response: { data: _data } = {} } = a;
                      const file = {
                        uid: a.uid,
                        name: a.name,
                        // 兼容工单和CRM上传成功返回的数据结构差异
                        url: _data ? _data.file_url || _data : undefined,
                      };
                      arr.push({ file });
                    }
                    if (!a.status) {
                      const file = {
                        uid: a.uid,
                        name: a.name,
                        url: a.url || undefined,
                      };
                      arr.push({ file });
                    }
                  });
                  data[a.name] = JSON.stringify(arr);
                } else if (
                  a.type === 'datetime' &&
                  data[a.name] &&
                  data[a.name].format
                ) {
                  data[a.name] = data[a.name].format(a.options.dateFormat);
                }
              });
            }
          });
        } else if (
          item.type === 'datetime' &&
          data[item.name] &&
          data[item.name].format
        ) {
          // data[item.name] = data[item.name]._f
          //   ? data[item.name].format(data[item.name]._f)
          //   : data[item.name].format("YYYY-MM-DD");
          data[item.name] = data[item.name].format(item.options.dateFormat);
        }
      });
    });
    if (flag === 0) return [0];
    if (flag === 2) return [2];
    for (const i in data) {
      data[i] = data[i] === undefined ? null : data[i];
    }
    return [1, data];
  };

  render() {
    const {
      form,
      smallScreen = false,
      formItemLayout = {},
      className,
      storeFormData,
    } = this.props;
    const {
      totalData: { formData = [], formMatrix = [] } = {},
      options = {},
      customProps,
      customRules, // only use for commonTypes
      customOptions,
      totalData,
    } = this.state;
    return (
      <div
        className={classnames(
          {
            'form-show-container': true,
            'form-show-container-small': !!smallScreen,
          },
          className,
        )}
      >
        {formMatrix.map((row, rowIdx) => (
          <FormRow
            data={formData.filter(item => item.rowKey === row.key)}
            rowIdx={rowIdx}
            key={rowIdx}
            form={form}
            options={options}
            rowKey={row.key}
            columns={row.column}
            customProps={customProps}
            customOptions={customOptions}
            smallScreen={smallScreen}
            formItemLayout={formItemLayout}
            customRules={customRules}
            storeFormData={storeFormData}
          />
        ))}
      </div>
    );
  }
}

export default Form.create()(ShowForm);

// //深拷贝
// function deepClone(initalObj, finalObj) {
//   var obj = finalObj || {};
//   for (var i in initalObj) {
//     if (typeof initalObj[i] === "object") {
//       obj[i] = initalObj[i].constructor === Array ? [] : {};
//       arguments.callee(initalObj[i], obj[i]);
//     } else {
//       obj[i] = initalObj[i];
//     }
//   }
//   return obj;
// }

function deepClone(arr) {
  const obj = arr instanceof Array ? [] : {};
  for (const item in arr) {
    if (typeof arr[item] === 'object') {
      obj[item] = deepClone(arr[item]);
    } else {
      obj[item] = arr[item];
    }
  }
  return obj;
}

function valueToLebal(valueArr, items, finalArr) {
  if (
    !items ||
    !Array.isArray(items) ||
    !items.length ||
    !valueArr ||
    !Array.isArray(valueArr) ||
    !valueArr.length
  )
    return undefined;
  valueArr.forEach(value => {
    items.forEach(item => {
      if (value === item.value) {
        finalArr.push(item.label);
        valueArr = valueArr.filter(arr => arr !== value);
        if (valueArr.length) {
          valueToLebal(valueArr, item.children, finalArr);
        }
      }
    });
  });
}

function labelToValue(labelArr, items, finalArr) {
  labelArr.forEach(value => {
    items.forEach(item => {
      if (value === item.label) {
        finalArr.push(item.value);
        labelArr = labelArr.filter(arr => arr !== value);
        if (labelArr.length) {
          return labelToValue(labelArr, item.children, finalArr);
        }
        return finalArr;
      }
    });
  });
}

// 表单回显过滤单选下拉不在列表中的值
function editSingleFilterUseless(value, items) {
  if (!items || !Array.isArray(items) || !items.length) return undefined;
  let select;
  items.forEach(item => {
    if (item.value == value) {
      select = item;
    }
  });
  return select;
}

// 表单回显过滤多选不在列表中的值
function editCheckFilterUseless(valueArr, items, finalArr) {
  if (
    !items ||
    !Array.isArray(items) ||
    !items.length ||
    !valueArr ||
    !Array.isArray(valueArr) ||
    !valueArr.length
  )
    return undefined;
  items.forEach(item => {
    if (valueArr.includes(item.value)) {
      finalArr.push(item.value);
    }
  });
  return finalArr;
}

// 表单回显过滤级联不在列表中的值
function editCascadeFilterUseless(valueArr, items, finalArr) {
  if (
    !items ||
    !Array.isArray(items) ||
    !items.length ||
    !valueArr ||
    !Array.isArray(valueArr) ||
    !valueArr.length
  )
    return undefined;
  valueArr.forEach(value => {
    items.forEach(item => {
      if (item.value === value) {
        finalArr.push(value);
        valueArr = valueArr.filter(arr => arr !== value);
        if (valueArr.length) {
          return editCascadeFilterUseless(valueArr, item.children, finalArr);
        }
        return finalArr;
      }
    });
  });
}

// 初始化接口过滤单选下拉不在列表中的值
function resetSingleFilterUseless(label, items) {
  if (!items || !Array.isArray(items) || !items.length) return undefined;
  let select;
  items.forEach(item => {
    if (item.text === label) {
      select = item;
    }
  });
  return select;
}

// 初始化接口过滤多选不在列表中的值
function resetCheckFilterUseless(labelArr, items, finalArr) {
  if (
    !items ||
    !Array.isArray(items) ||
    !items.length ||
    !labelArr ||
    !Array.isArray(labelArr) ||
    !labelArr.length
  )
    return undefined;
  items.forEach(item => {
    if (labelArr.includes(item.text)) {
      finalArr.push(item.text);
    }
  });
  return finalArr;
}

// 初始化接口过滤级联不在列表中的值
function resetCascadeFilterUseless(labelArr, items, finalArr) {
  if (
    !items ||
    !Array.isArray(items) ||
    !items.length ||
    !labelArr ||
    !Array.isArray(labelArr) ||
    !labelArr.length
  )
    return undefined;
  labelArr.forEach(label => {
    items.forEach(item => {
      if (item.text === label) {
        finalArr.push(label);
        labelArr = labelArr.filter(arr => arr !== label);
        if (labelArr.length) {
          return resetCascadeFilterUseless(labelArr, item.children, finalArr);
        }
        return finalArr;
      }
    });
  });
}

// 判断是否为日期格式
// 短日期，形如 (2008-09-13)
export function isShortDate(str) {
  const r = str.match(/^(\d{1,4})(-|\/)(\d{1,2})\2(\d{1,2})$/);
  if (r == null) return false;
  const d = new Date(r[1], r[3] - 1, r[4]);
  return (
    d.getFullYear() == r[1] && d.getMonth() + 1 == r[3] && d.getDate() == r[4]
  );
}
// 长时间，形如 (2008-09-13 23:30:06)
export function isLongDate(str) {
  const reg = /^(\d{1,4})(-|\/)(\d{1,2})\2(\d{1,2}) (\d{1,2}):(\d{1,2}):(\d{1,2})$/;
  const r = str.match(reg);
  if (r == null) return false;
  const d = new Date(r[1], r[3] - 1, r[4], r[5], r[6], r[7]);
  return (
    d.getFullYear() == r[1] &&
    d.getMonth() + 1 == r[3] &&
    d.getDate() == r[4] &&
    d.getHours() == r[5] &&
    d.getMinutes() == r[6] &&
    d.getSeconds() == r[7]
  );
}
